#jinja2: trim_blocks: True, lstrip_blocks: True
{{ ansible_managed | comment }}
# http://prometheus.io/docs/operating/configuration/

global:
  {{ prometheus_global | to_nice_yaml(indent=2) | indent(2, False) }}
  external_labels:
    datacentre: '{{ prometheus_datacentre }}'

{% if prometheus_remote_write != [] %}
remote_write:
  {{ prometheus_remote_write | to_nice_yaml(indent=2) | indent(2, False) }}
{% endif %}

{% if prometheus_remote_read != [] %}
remote_read:
  {{ prometheus_remote_read | to_nice_yaml(indent=2) | indent(2, False) }}
{% endif %}

rule_files:
  - {{ prometheus_config_dir }}/rules/*.rules

{% if prometheus_alertmanager_config | length > 0 %}
alerting:
  alertmanagers:
  {{ prometheus_alertmanager_config | to_nice_yaml(indent=2) | indent(2,False) }}
  alert_relabel_configs:
  # prometheus_static_node_metric_relabel_configs
  {{ prometheus_static_node_metric_relabel_configs | to_nice_yaml(indent=2) | indent(2,False) }}
  # elasticsearch_instance_add_cluster_label
  {{ elasticsearch_instance_add_cluster_label | to_nice_yaml(indent=2) | indent(2,False) }}
  # prometheus_node_metric_relabel_configs
{% if prometheus_node_metric_relabel_configs | length > 0 %}
  {{ prometheus_node_metric_relabel_configs | to_nice_yaml(indent=2) | indent(2,False) }}
{% endif %}
{% endif %}

scrape_configs:
  {{ prometheus_scrape_configs | to_nice_yaml(indent=2) | indent(2,False) }}

  - job_name: 'blackbox'
    metrics_path: /probe
    params:
      module: [ssh_banner]
    static_configs:
      - targets:
        {{ blackbox_ssh_targets | to_nice_yaml(indent=8) | indent(8,False) }} # Targets to probe
    relabel_configs:
      # Ensure port is 22, pass as URL parameter
      - source_labels: [__address__]
        regex: (.*?)(:.*)?
        replacement: ${1}:22
        target_label: __param_target
      # Make instance label the target
      - source_labels: [__param_target]
        target_label: instance
      # Actually talk to the blackbox exporter though
      - target_label: __address__
        replacement: {{ ansible_fqdn | default(ansible_host) | default('localhost') }}:9115

{% if k8s_api_server | length > 0 %}

# Deprecated - pxh
  # - job_name: kube-scheduler
  #   static_configs:
  #   - targets:
  #     - "{{ k8s_api_server_addr }}:10251"

  ## Disable kube-proxy job as it is not open on kubernetes-v1 - PXH
  # - job_name: kube-proxy
  #   static_configs:
  #   - targets:
  #     - "{{ k8s_api_server_addr }}:10249"

# Deprecated - pxh
  # - job_name: kube-controller-manager
  #   static_configs:
  #   - targets:
  #     - "{{ k8s_api_server_addr }}:10252"

# https://github.com/prometheus/prometheus/blob/master/documentation/examples/prometheus-kubernetes.yml
  - job_name: 'kube-apiserver'
    kubernetes_sd_configs:
    - role: endpoints
      api_server: "{{ k8s_api_server }}"
      # TLS config required in two places
      tls_config:
        ca_file: /etc/prometheus/ca.crt
      bearer_token_file: {{ k8s_bearer_token }}
    scheme: https
    # TLS config required in two places
    tls_config:
      ca_file: /etc/prometheus/ca.crt
    bearer_token_file: {{ k8s_bearer_token }}
    relabel_configs:
    - source_labels: [__meta_kubernetes_namespace, __meta_kubernetes_service_name, __meta_kubernetes_endpoint_port_name]
      action: keep
      regex: default;kubernetes;https

  - job_name: 'kubelet'
    kubernetes_sd_configs:
    - role: node
      api_server: "{{ k8s_api_server }}"
      # TLS config required in two places
      tls_config:
        ca_file: /etc/prometheus/ca.crt
      bearer_token_file: {{ k8s_bearer_token }}
    scheme: https
    # TLS config required in two places
    tls_config:
      insecure_skip_verify: true
    bearer_token_file: {{ k8s_bearer_token }}
    metric_relabel_configs:
    - action: labelmap
      regex: __meta_kubernetes_node_label_(.+)
    - target_label: __address__
      replacement: kubernetes.default.svc:443
    - source_labels: [__meta_kubernetes_node_name]
      regex: (.+)
      target_label: __metrics_path__
      replacement: /api/v1/nodes/${1}/proxy/metrics

  # - job_name: 'cadvisor'
  #   kubernetes_sd_configs:
  #   - role: node
  #     api_server: "{{ k8s_api_server }}"
  #     # TLS config required in two places
  #     tls_config:
  #       ca_file: /etc/prometheus/ca.crt
  #     bearer_token_file: {{ k8s_bearer_token }}
  #   scheme: https
  #   # TLS config required in two places
  #   tls_config:
  #     insecure_skip_verify: true
  #   bearer_token_file: {{ k8s_bearer_token }}
  #   #metrics_path: /metrics/cadvisor
  #   relabel_configs:
  #   - action: labelmap
  #     regex: __meta_kubernetes_node_label_(.+)
  #   - target_label: __address__
  #     replacement: kubernetes.default.svc:443
  #   - source_labels: [__meta_kubernetes_node_name]
  #     regex: (.+)
  #     target_label: __metrics_path__
  #     replacement: /api/v1/nodes/${1}/proxy/metrics/cadvisor

  - job_name: 'cadvisor'
    kubernetes_sd_configs:
    - role: node
      api_server: "{{ k8s_api_server }}"
      # TLS config required in two places
      tls_config:
        ca_file: /etc/prometheus/ca.crt
      bearer_token_file: {{ k8s_bearer_token }}
    scheme: https
    # TLS config required in two places
    tls_config:
      insecure_skip_verify: true
    bearer_token_file: {{ k8s_bearer_token }}
    metrics_path: /metrics/cadvisor

{% endif %}